package com.kingdee.eas.custom.dormitorysystem.application;

import com.kingdee.bos.framework.ejb.EJBRemoteException;
import com.kingdee.bos.util.BOSObjectType;
import java.rmi.RemoteException;
import com.kingdee.bos.framework.AbstractBizCtrl;
import com.kingdee.bos.orm.template.ORMObject;

import com.kingdee.bos.util.*;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.bos.Context;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.hr.base.IHRBillBase;
import com.kingdee.eas.custom.dormitorysystem.application.app.*;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.BOSException;
import com.kingdee.eas.hr.base.HRBillBase;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import java.lang.String;
import com.kingdee.bos.framework.*;

public class CheckoutApplication extends HRBillBase implements ICheckoutApplication
{
    public CheckoutApplication()
    {
        super();
        registerInterface(ICheckoutApplication.class, this);
    }
    public CheckoutApplication(Context ctx)
    {
        super(ctx);
        registerInterface(ICheckoutApplication.class, this);
    }
    public BOSObjectType getType()
    {
        return new BOSObjectType("EBE6D24D");
    }
    private CheckoutApplicationController getController() throws BOSException
    {
        return (CheckoutApplicationController)getBizController();
    }
    /**
     *ȡ-System defined method
     *@return
     */
    public CheckoutApplicationCollection getCheckoutApplicationCollection() throws BOSException
    {
        try {
            return getController().getCheckoutApplicationCollection(getContext());
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡ-System defined method
     *@param view ȡ
     *@return
     */
    public CheckoutApplicationCollection getCheckoutApplicationCollection(EntityViewInfo view) throws BOSException
    {
        try {
            return getController().getCheckoutApplicationCollection(getContext(), view);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡ-System defined method
     *@param oql ȡ
     *@return
     */
    public CheckoutApplicationCollection getCheckoutApplicationCollection(String oql) throws BOSException
    {
        try {
            return getController().getCheckoutApplicationCollection(getContext(), oql);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡֵ-System defined method
     *@param pk ȡֵ
     *@return
     */
    public CheckoutApplicationInfo getCheckoutApplicationInfo(IObjectPK pk) throws BOSException, EASBizException
    {
        try {
            return getController().getCheckoutApplicationInfo(getContext(), pk);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡֵ-System defined method
     *@param pk ȡֵ
     *@param selector ȡֵ
     *@return
     */
    public CheckoutApplicationInfo getCheckoutApplicationInfo(IObjectPK pk, SelectorItemCollection selector) throws BOSException, EASBizException
    {
        try {
            return getController().getCheckoutApplicationInfo(getContext(), pk, selector);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡֵ-System defined method
     *@param oql ȡֵ
     *@return
     */
    public CheckoutApplicationInfo getCheckoutApplicationInfo(String oql) throws BOSException, EASBizException
    {
        try {
            return getController().getCheckoutApplicationInfo(getContext(), oql);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ύЧ-User defined method
     *@param billId id
     *@return
     */
    public IObjectPK submitEffect(String billId) throws BOSException, EASBizException
    {
        try {
            return getController().submitEffect(getContext(), billId);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ڵ֮УµݣҪͷtrue򷵻falseдУǷԭ-User defined method
     *@param billID id
     *@return
     */
    public boolean validateBillInProcess(BOSUuid billID) throws BOSException, EASBizException
    {
        try {
            return getController().validateBillInProcess(getContext(), billID);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
}