/**
 * output package name
 */
package com.kingdee.eas.custom.dormitorysystem.waterelectricity.client;

import org.apache.log4j.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.border.*;
import javax.swing.BorderFactory;
import javax.swing.event.*;
import javax.swing.KeyStroke;

import com.kingdee.bos.ctrl.swing.*;
import com.kingdee.bos.ctrl.kdf.table.*;
import com.kingdee.bos.ctrl.kdf.data.event.*;
import com.kingdee.bos.dao.*;
import com.kingdee.bos.dao.query.*;
import com.kingdee.bos.metadata.*;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.ui.face.*;
import com.kingdee.bos.ui.util.ResourceBundleHelper;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.bos.service.ServiceContext;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.util.enums.EnumUtils;
import com.kingdee.bos.ui.face.UIRuleUtil;
import com.kingdee.bos.ctrl.swing.event.*;
import com.kingdee.bos.ctrl.kdf.table.event.*;
import com.kingdee.bos.ctrl.extendcontrols.*;
import com.kingdee.bos.ctrl.kdf.util.render.*;
import com.kingdee.bos.ui.face.IItemAction;
import com.kingdee.eas.framework.batchHandler.RequestContext;
import com.kingdee.bos.ui.util.IUIActionPostman;
import com.kingdee.bos.appframework.client.servicebinding.ActionProxyFactory;
import com.kingdee.bos.appframework.uistatemanage.ActionStateConst;
import com.kingdee.bos.appframework.validator.ValidateHelper;
import com.kingdee.bos.appframework.uip.UINavigator;


/**
 * output class name
 */
public abstract class AbstractWaterElectricityEditUI extends com.kingdee.eas.hr.base.client.HRBillEditUI
{
    private static final Logger logger = CoreUIObject.getLogger(AbstractWaterElectricityEditUI.class);
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contNumber;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contDescription;
    protected com.kingdee.bos.ctrl.kdf.table.KDTable kdtEntrys;
	protected com.kingdee.eas.framework.client.multiDetail.DetailPanel kdtEntrys_detailPanel = null;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contApplier;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contAdminOrg;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contApplyDate;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contBillState;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contyearMonth;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contperson;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contempName;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contempNumber;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contpositionStatus;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contleaveDate;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contdormitory;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contwaterTotalCost;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contelectricityTotalCost;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contmonthWaterAmount;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contmonthElectricityAmount;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contmonthDays;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contstutas;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contmeterReading;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer conthydropowerStandards;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contposition;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contstartDate;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contendDate;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contallMonthDays;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtNumber;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtDescription;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtApplier;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtAdminOrg;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker dpApplyDate;
    protected com.kingdee.bos.ctrl.swing.KDComboBox cbBillState;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtyearMonth;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtperson;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtempName;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtempNumber;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtpositionStatus;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkleaveDate;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtdormitory;
    protected com.kingdee.bos.ctrl.swing.KDFormattedTextField txtwaterTotalCost;
    protected com.kingdee.bos.ctrl.swing.KDFormattedTextField txtelectricityTotalCost;
    protected com.kingdee.bos.ctrl.swing.KDFormattedTextField txtmonthWaterAmount;
    protected com.kingdee.bos.ctrl.swing.KDFormattedTextField txtmonthElectricityAmount;
    protected com.kingdee.bos.ctrl.swing.KDFormattedTextField txtmonthDays;
    protected com.kingdee.bos.ctrl.swing.KDComboBox stutas;
    protected com.kingdee.bos.ctrl.swing.KDScrollPane scrollPanemeterReading;
    protected com.kingdee.bos.ctrl.swing.KDTextArea txtmeterReading;
    protected com.kingdee.bos.ctrl.swing.KDScrollPane scrollPanehydropowerStandards;
    protected com.kingdee.bos.ctrl.swing.KDTextArea txthydropowerStandards;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtposition;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkstartDate;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkendDate;
    protected com.kingdee.bos.ctrl.swing.KDFormattedTextField txtallMonthDays;
    protected com.kingdee.eas.custom.dormitorysystem.waterelectricity.WaterElectricityInfo editData = null;
    /**
     * output class constructor
     */
    public AbstractWaterElectricityEditUI() throws Exception
    {
        super();
        this.defaultObjectName = "editData";
        jbInit();
        
        initUIP();
    }

    /**
     * output jbInit method
     */
    private void jbInit() throws Exception
    {
        this.resHelper = new ResourceBundleHelper(AbstractWaterElectricityEditUI.class.getName());
        this.setUITitle(resHelper.getString("this.title"));
        //actionSubmit
        String _tempStr = null;
        actionSubmit.setEnabled(true);
        actionSubmit.setDaemonRun(false);

        actionSubmit.putValue(ItemAction.ACCELERATOR_KEY, KeyStroke.getKeyStroke("ctrl S"));
        _tempStr = resHelper.getString("ActionSubmit.SHORT_DESCRIPTION");
        actionSubmit.putValue(ItemAction.SHORT_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionSubmit.LONG_DESCRIPTION");
        actionSubmit.putValue(ItemAction.LONG_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionSubmit.NAME");
        actionSubmit.putValue(ItemAction.NAME, _tempStr);
        this.actionSubmit.setBindWorkFlow(true);
         this.actionSubmit.addService(new com.kingdee.eas.framework.client.service.PermissionService());
         this.actionSubmit.addService(new com.kingdee.eas.framework.client.service.NetFunctionService());
         this.actionSubmit.addService(new com.kingdee.eas.framework.client.service.UserMonitorService());
        //actionPrint
        actionPrint.setEnabled(true);
        actionPrint.setDaemonRun(false);

        actionPrint.putValue(ItemAction.ACCELERATOR_KEY, KeyStroke.getKeyStroke("ctrl P"));
        _tempStr = resHelper.getString("ActionPrint.SHORT_DESCRIPTION");
        actionPrint.putValue(ItemAction.SHORT_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionPrint.LONG_DESCRIPTION");
        actionPrint.putValue(ItemAction.LONG_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionPrint.NAME");
        actionPrint.putValue(ItemAction.NAME, _tempStr);
         this.actionPrint.addService(new com.kingdee.eas.framework.client.service.PermissionService());
         this.actionPrint.addService(new com.kingdee.eas.framework.client.service.NetFunctionService());
         this.actionPrint.addService(new com.kingdee.eas.framework.client.service.UserMonitorService());
        //actionPrintPreview
        actionPrintPreview.setEnabled(true);
        actionPrintPreview.setDaemonRun(false);

        actionPrintPreview.putValue(ItemAction.ACCELERATOR_KEY, KeyStroke.getKeyStroke("shift ctrl P"));
        _tempStr = resHelper.getString("ActionPrintPreview.SHORT_DESCRIPTION");
        actionPrintPreview.putValue(ItemAction.SHORT_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionPrintPreview.LONG_DESCRIPTION");
        actionPrintPreview.putValue(ItemAction.LONG_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionPrintPreview.NAME");
        actionPrintPreview.putValue(ItemAction.NAME, _tempStr);
         this.actionPrintPreview.addService(new com.kingdee.eas.framework.client.service.PermissionService());
         this.actionPrintPreview.addService(new com.kingdee.eas.framework.client.service.NetFunctionService());
         this.actionPrintPreview.addService(new com.kingdee.eas.framework.client.service.UserMonitorService());
        //actionAudit
        actionAudit.setEnabled(true);
        actionAudit.setDaemonRun(false);

        actionAudit.putValue(ItemAction.ACCELERATOR_KEY, KeyStroke.getKeyStroke("ctrl A"));
        _tempStr = resHelper.getString("ActionAudit.SHORT_DESCRIPTION");
        actionAudit.putValue(ItemAction.SHORT_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionAudit.LONG_DESCRIPTION");
        actionAudit.putValue(ItemAction.LONG_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionAudit.NAME");
        actionAudit.putValue(ItemAction.NAME, _tempStr);
         this.actionAudit.addService(new com.kingdee.eas.framework.client.service.PermissionService());
        //actionUnaudit
        actionUnaudit.setEnabled(true);
        actionUnaudit.setDaemonRun(false);

        actionUnaudit.putValue(ItemAction.ACCELERATOR_KEY, KeyStroke.getKeyStroke("ctrl U"));
        _tempStr = resHelper.getString("ActionUnaudit.SHORT_DESCRIPTION");
        actionUnaudit.putValue(ItemAction.SHORT_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionUnaudit.LONG_DESCRIPTION");
        actionUnaudit.putValue(ItemAction.LONG_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionUnaudit.NAME");
        actionUnaudit.putValue(ItemAction.NAME, _tempStr);
         this.actionUnaudit.addService(new com.kingdee.eas.framework.client.service.PermissionService());
        this.contNumber = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contDescription = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.kdtEntrys = new com.kingdee.bos.ctrl.kdf.table.KDTable();
        this.contApplier = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contAdminOrg = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contApplyDate = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contBillState = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contyearMonth = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contperson = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contempName = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contempNumber = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contpositionStatus = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contleaveDate = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contdormitory = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contwaterTotalCost = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contelectricityTotalCost = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contmonthWaterAmount = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contmonthElectricityAmount = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contmonthDays = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contstutas = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contmeterReading = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.conthydropowerStandards = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contposition = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contstartDate = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contendDate = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contallMonthDays = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.txtNumber = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtDescription = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtApplier = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.prmtAdminOrg = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.dpApplyDate = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.cbBillState = new com.kingdee.bos.ctrl.swing.KDComboBox();
        this.txtyearMonth = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.prmtperson = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.txtempName = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtempNumber = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtpositionStatus = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.pkleaveDate = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.prmtdormitory = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.txtwaterTotalCost = new com.kingdee.bos.ctrl.swing.KDFormattedTextField();
        this.txtelectricityTotalCost = new com.kingdee.bos.ctrl.swing.KDFormattedTextField();
        this.txtmonthWaterAmount = new com.kingdee.bos.ctrl.swing.KDFormattedTextField();
        this.txtmonthElectricityAmount = new com.kingdee.bos.ctrl.swing.KDFormattedTextField();
        this.txtmonthDays = new com.kingdee.bos.ctrl.swing.KDFormattedTextField();
        this.stutas = new com.kingdee.bos.ctrl.swing.KDComboBox();
        this.scrollPanemeterReading = new com.kingdee.bos.ctrl.swing.KDScrollPane();
        this.txtmeterReading = new com.kingdee.bos.ctrl.swing.KDTextArea();
        this.scrollPanehydropowerStandards = new com.kingdee.bos.ctrl.swing.KDScrollPane();
        this.txthydropowerStandards = new com.kingdee.bos.ctrl.swing.KDTextArea();
        this.prmtposition = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.pkstartDate = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.pkendDate = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.txtallMonthDays = new com.kingdee.bos.ctrl.swing.KDFormattedTextField();
        this.contNumber.setName("contNumber");
        this.contDescription.setName("contDescription");
        this.kdtEntrys.setName("kdtEntrys");
        this.contApplier.setName("contApplier");
        this.contAdminOrg.setName("contAdminOrg");
        this.contApplyDate.setName("contApplyDate");
        this.contBillState.setName("contBillState");
        this.contyearMonth.setName("contyearMonth");
        this.contperson.setName("contperson");
        this.contempName.setName("contempName");
        this.contempNumber.setName("contempNumber");
        this.contpositionStatus.setName("contpositionStatus");
        this.contleaveDate.setName("contleaveDate");
        this.contdormitory.setName("contdormitory");
        this.contwaterTotalCost.setName("contwaterTotalCost");
        this.contelectricityTotalCost.setName("contelectricityTotalCost");
        this.contmonthWaterAmount.setName("contmonthWaterAmount");
        this.contmonthElectricityAmount.setName("contmonthElectricityAmount");
        this.contmonthDays.setName("contmonthDays");
        this.contstutas.setName("contstutas");
        this.contmeterReading.setName("contmeterReading");
        this.conthydropowerStandards.setName("conthydropowerStandards");
        this.contposition.setName("contposition");
        this.contstartDate.setName("contstartDate");
        this.contendDate.setName("contendDate");
        this.contallMonthDays.setName("contallMonthDays");
        this.txtNumber.setName("txtNumber");
        this.txtDescription.setName("txtDescription");
        this.txtApplier.setName("txtApplier");
        this.prmtAdminOrg.setName("prmtAdminOrg");
        this.dpApplyDate.setName("dpApplyDate");
        this.cbBillState.setName("cbBillState");
        this.txtyearMonth.setName("txtyearMonth");
        this.prmtperson.setName("prmtperson");
        this.txtempName.setName("txtempName");
        this.txtempNumber.setName("txtempNumber");
        this.txtpositionStatus.setName("txtpositionStatus");
        this.pkleaveDate.setName("pkleaveDate");
        this.prmtdormitory.setName("prmtdormitory");
        this.txtwaterTotalCost.setName("txtwaterTotalCost");
        this.txtelectricityTotalCost.setName("txtelectricityTotalCost");
        this.txtmonthWaterAmount.setName("txtmonthWaterAmount");
        this.txtmonthElectricityAmount.setName("txtmonthElectricityAmount");
        this.txtmonthDays.setName("txtmonthDays");
        this.stutas.setName("stutas");
        this.scrollPanemeterReading.setName("scrollPanemeterReading");
        this.txtmeterReading.setName("txtmeterReading");
        this.scrollPanehydropowerStandards.setName("scrollPanehydropowerStandards");
        this.txthydropowerStandards.setName("txthydropowerStandards");
        this.prmtposition.setName("prmtposition");
        this.pkstartDate.setName("pkstartDate");
        this.pkendDate.setName("pkendDate");
        this.txtallMonthDays.setName("txtallMonthDays");
        // CoreUI		
        this.btnPrint.setVisible(false);		
        this.btnPrintPreview.setVisible(false);		
        this.menuItemPrint.setVisible(false);		
        this.menuItemPrintPreview.setVisible(false);		
        this.btnTraceUp.setVisible(false);		
        this.btnTraceDown.setVisible(false);		
        this.btnCreateFrom.setVisible(false);		
        this.btnAddLine.setVisible(false);		
        this.btnInsertLine.setVisible(false);		
        this.btnRemoveLine.setVisible(false);		
        this.btnAuditResult.setVisible(false);		
        this.separator1.setVisible(false);		
        this.menuItemCreateFrom.setVisible(false);		
        this.menuItemCopyFrom.setVisible(false);		
        this.separator3.setVisible(false);		
        this.menuItemTraceUp.setVisible(false);		
        this.menuItemTraceDown.setVisible(false);		
        this.menuItemAddLine.setVisible(false);		
        this.menuItemInsertLine.setVisible(false);		
        this.menuItemRemoveLine.setVisible(false);		
        this.menuItemViewSubmitProccess.setVisible(false);		
        this.menuItemViewDoProccess.setVisible(false);		
        this.menuItemAuditResult.setVisible(false);		
        this.contHROrg.setBoundLabelText(resHelper.getString("contHROrg.boundLabelText"));		
        this.contHROrg.setBoundLabelLength(90);		
        this.contHROrg.setBoundLabelUnderline(true);		
        this.contHROrg.setBoundLabelAlignment(7);		
        this.contHROrg.setVisible(true);		
        this.contApproveType.setBoundLabelText(resHelper.getString("contApproveType.boundLabelText"));		
        this.contApproveType.setBoundLabelLength(90);		
        this.contApproveType.setBoundLabelUnderline(true);		
        this.contApproveType.setBoundLabelAlignment(7);		
        this.contApproveType.setVisible(true);		
        this.prmtHROrg.setRequired(true);		
        this.prmtHROrg.setVisible(true);		
        this.prmtHROrg.setEnabled(true);		
        this.cbApproveType.setRequired(true);		
        this.cbApproveType.setVisible(true);		
        this.cbApproveType.setEnabled(true);
        this.btnAudit.setAction((IItemAction)ActionProxyFactory.getProxy(actionAudit, new Class[] { IItemAction.class }, getServiceContext()));		
        this.btnAudit.setText(resHelper.getString("btnAudit.text"));		
        this.btnAudit.setToolTipText(resHelper.getString("btnAudit.toolTipText"));		
        this.btnAudit.setIcon(com.kingdee.eas.util.client.EASResource.getIcon("imgTbtn_audit"));
        this.btnUnaudit.setAction((IItemAction)ActionProxyFactory.getProxy(actionUnaudit, new Class[] { IItemAction.class }, getServiceContext()));		
        this.btnUnaudit.setText(resHelper.getString("btnUnaudit.text"));		
        this.btnUnaudit.setIcon(com.kingdee.eas.util.client.EASResource.getIcon("imgTbtn_unaudit"));		
        this.btnUnaudit.setToolTipText(resHelper.getString("btnUnaudit.toolTipText"));		
        this.btnUnaudit.setVisible(false);
        this.menuItemAudit.setAction((IItemAction)ActionProxyFactory.getProxy(actionAudit, new Class[] { IItemAction.class }, getServiceContext()));		
        this.menuItemAudit.setText(resHelper.getString("menuItemAudit.text"));		
        this.menuItemAudit.setToolTipText(resHelper.getString("menuItemAudit.toolTipText"));		
        this.menuItemAudit.setMnemonic(65);		
        this.menuItemAudit.setIcon(com.kingdee.eas.util.client.EASResource.getIcon("imgTbtn_audit"));
        this.menuItemUnaudit.setAction((IItemAction)ActionProxyFactory.getProxy(actionUnaudit, new Class[] { IItemAction.class }, getServiceContext()));		
        this.menuItemUnaudit.setText(resHelper.getString("menuItemUnaudit.text"));		
        this.menuItemUnaudit.setToolTipText(resHelper.getString("menuItemUnaudit.toolTipText"));		
        this.menuItemUnaudit.setMnemonic(85);		
        this.menuItemUnaudit.setIcon(com.kingdee.eas.util.client.EASResource.getIcon("imgTbtn_unaudit"));		
        this.menuItemUnaudit.setVisible(false);
        // contNumber		
        this.contNumber.setBoundLabelText(resHelper.getString("contNumber.boundLabelText"));		
        this.contNumber.setBoundLabelLength(90);		
        this.contNumber.setBoundLabelUnderline(true);		
        this.contNumber.setBoundLabelAlignment(7);		
        this.contNumber.setVisible(true);
        // contDescription		
        this.contDescription.setBoundLabelText(resHelper.getString("contDescription.boundLabelText"));		
        this.contDescription.setBoundLabelLength(90);		
        this.contDescription.setBoundLabelUnderline(true);		
        this.contDescription.setBoundLabelAlignment(7);		
        this.contDescription.setVisible(true);
        // kdtEntrys
		String kdtEntrysStrXML = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><DocRoot xmlns:c=\"http://www.kingdee.com/Common\" xmlns:f=\"http://www.kingdee.com/Form\" xmlns:t=\"http://www.kingdee.com/Table\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.kingdee.com/KDF KDFSchema.xsd\" version=\"0.0\"><Styles><c:Style id=\"sCol0\"><c:Protection hidden=\"true\" /></c:Style><c:Style id=\"sCol1\"><c:Protection locked=\"true\" hidden=\"true\" /></c:Style><c:Style id=\"sCol2\"><c:Protection locked=\"true\" /></c:Style><c:Style id=\"sCol3\"><c:Protection locked=\"true\" /></c:Style><c:Style id=\"sCol4\"><c:Protection locked=\"true\" /></c:Style><c:Style id=\"sCol5\"><c:Protection locked=\"true\" /></c:Style><c:Style id=\"sCol6\"><c:NumberFormat>yyyy-mm-dd</c:NumberFormat></c:Style><c:Style id=\"sCol9\"><c:NumberFormat>&amp;date</c:NumberFormat></c:Style><c:Style id=\"sCol11\"><c:NumberFormat>&amp;double</c:NumberFormat></c:Style><c:Style id=\"sCol12\"><c:NumberFormat>&amp;double</c:NumberFormat></c:Style><c:Style id=\"sCol13\"><c:NumberFormat>&amp;double</c:NumberFormat></c:Style><c:Style id=\"sCol14\"><c:NumberFormat>&amp;double</c:NumberFormat></c:Style><c:Style id=\"sCol15\"><c:NumberFormat>&amp;double</c:NumberFormat></c:Style><c:Style id=\"sCol18\"><c:NumberFormat>&amp;date</c:NumberFormat></c:Style><c:Style id=\"sCol19\"><c:NumberFormat>&amp;date</c:NumberFormat></c:Style></Styles><Table id=\"KDTable\"><t:Sheet name=\"sheet1\"><t:Table t:selectMode=\"15\" t:mergeMode=\"0\" t:dataRequestMode=\"0\" t:pageRowCount=\"100\"><t:ColumnGroup><t:Column t:key=\"id\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" t:styleID=\"sCol0\" /><t:Column t:key=\"person\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"2\" t:styleID=\"sCol1\" /><t:Column t:key=\"empNumber\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"3\" t:styleID=\"sCol2\" /><t:Column t:key=\"empName\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"4\" t:styleID=\"sCol3\" /><t:Column t:key=\"position\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"9\" t:styleID=\"sCol4\" /><t:Column t:key=\"adminOrg\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"10\" t:styleID=\"sCol5\" /><t:Column t:key=\"bizDate\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"true\" t:index=\"14\" t:styleID=\"sCol6\" /><t:Column t:key=\"description\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"15\" /><t:Column t:key=\"yearMonth\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" /><t:Column t:key=\"leaveDate\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" t:styleID=\"sCol9\" /><t:Column t:key=\"dormitory\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" /><t:Column t:key=\"waterTotalCost\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" t:styleID=\"sCol11\" /><t:Column t:key=\"electricityTotalCost\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" t:styleID=\"sCol12\" /><t:Column t:key=\"monthWaterAmount\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" t:styleID=\"sCol13\" /><t:Column t:key=\"monthElectricityAmount\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" t:styleID=\"sCol14\" /><t:Column t:key=\"monthDays\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" t:styleID=\"sCol15\" /><t:Column t:key=\"stutas\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" /><t:Column t:key=\"positionStatus\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" /><t:Column t:key=\"startDate\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" t:styleID=\"sCol18\" /><t:Column t:key=\"endDate\" t:width=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\" t:moveable=\"true\" t:group=\"false\" t:required=\"false\" t:index=\"-1\" t:styleID=\"sCol19\" /></t:ColumnGroup><t:Head><t:Row t:name=\"header\" t:height=\"-1\" t:mergeable=\"true\" t:resizeable=\"true\"><t:Cell>$Resource{id}</t:Cell><t:Cell>$Resource{person}</t:Cell><t:Cell>$Resource{empNumber}</t:Cell><t:Cell>$Resource{empName}</t:Cell><t:Cell>$Resource{position}</t:Cell><t:Cell>$Resource{adminOrg}</t:Cell><t:Cell>$Resource{bizDate}</t:Cell><t:Cell>$Resource{description}</t:Cell><t:Cell>$Resource{yearMonth}</t:Cell><t:Cell>$Resource{leaveDate}</t:Cell><t:Cell>$Resource{dormitory}</t:Cell><t:Cell>$Resource{waterTotalCost}</t:Cell><t:Cell>$Resource{electricityTotalCost}</t:Cell><t:Cell>$Resource{monthWaterAmount}</t:Cell><t:Cell>$Resource{monthElectricityAmount}</t:Cell><t:Cell>$Resource{monthDays}</t:Cell><t:Cell>$Resource{stutas}</t:Cell><t:Cell>$Resource{positionStatus}</t:Cell><t:Cell>$Resource{startDate}</t:Cell><t:Cell>$Resource{endDate}</t:Cell></t:Row></t:Head></t:Table><t:SheetOptions><t:MergeBlocks><t:Head /></t:MergeBlocks></t:SheetOptions></t:Sheet></Table></DocRoot>";
		
        this.kdtEntrys.setFormatXml(resHelper.translateString("kdtEntrys",kdtEntrysStrXML));
        this.kdtEntrys.addKDTEditListener(new com.kingdee.bos.ctrl.kdf.table.event.KDTEditAdapter() {
            public void editStopping(com.kingdee.bos.ctrl.kdf.table.event.KDTEditEvent e) {
                try {
                    kdtEntrys_editStopping(e);
                } catch(Exception exc) {
                    handUIException(exc);
                }
            }
            public void editStopped(com.kingdee.bos.ctrl.kdf.table.event.KDTEditEvent e) {
                try {
                    kdtEntrys_editStopped(e);
                } catch(Exception exc) {
                    handUIException(exc);
                }
            }
        });

                this.kdtEntrys.putBindContents("editData",new String[] {"id","person","person.number","person.name","position","adminOrg","bizDate","description","yearMonth","leaveDate","dormitory","waterTotalCost","electricityTotalCost","monthWaterAmount","monthElectricityAmount","monthDays","stutas","positionStatus","startDate","endDate"});


        this.kdtEntrys.checkParsed();
        final KDBizPromptBox kdtEntrys_person_PromptBox = new KDBizPromptBox();
        kdtEntrys_person_PromptBox.setQueryInfo("com.kingdee.eas.basedata.person.app.PersonQuery");
        kdtEntrys_person_PromptBox.setVisible(true);
        kdtEntrys_person_PromptBox.setEditable(true);
        kdtEntrys_person_PromptBox.setDisplayFormat("$number$");
        kdtEntrys_person_PromptBox.setEditFormat("$number$");
        kdtEntrys_person_PromptBox.setCommitFormat("$number$");
        KDTDefaultCellEditor kdtEntrys_person_CellEditor = new KDTDefaultCellEditor(kdtEntrys_person_PromptBox);
        this.kdtEntrys.getColumn("person").setEditor(kdtEntrys_person_CellEditor);
        ObjectValueRender kdtEntrys_person_OVR = new ObjectValueRender();
        kdtEntrys_person_OVR.setFormat(new BizDataFormat("$name$"));
        this.kdtEntrys.getColumn("person").setRenderer(kdtEntrys_person_OVR);
        KDTextField kdtEntrys_empName_TextField = new KDTextField();
        kdtEntrys_empName_TextField.setName("kdtEntrys_empName_TextField");
        kdtEntrys_empName_TextField.setMaxLength(80);
        KDTDefaultCellEditor kdtEntrys_empName_CellEditor = new KDTDefaultCellEditor(kdtEntrys_empName_TextField);
        this.kdtEntrys.getColumn("empName").setEditor(kdtEntrys_empName_CellEditor);
        final KDBizPromptBox kdtEntrys_position_PromptBox = new KDBizPromptBox();
        kdtEntrys_position_PromptBox.setQueryInfo("com.kingdee.eas.basedata.org.app.PositionQuery");
        kdtEntrys_position_PromptBox.setVisible(true);
        kdtEntrys_position_PromptBox.setEditable(true);
        kdtEntrys_position_PromptBox.setDisplayFormat("$number$");
        kdtEntrys_position_PromptBox.setEditFormat("$number$");
        kdtEntrys_position_PromptBox.setCommitFormat("$number$");
        KDTDefaultCellEditor kdtEntrys_position_CellEditor = new KDTDefaultCellEditor(kdtEntrys_position_PromptBox);
        this.kdtEntrys.getColumn("position").setEditor(kdtEntrys_position_CellEditor);
        ObjectValueRender kdtEntrys_position_OVR = new ObjectValueRender();
        kdtEntrys_position_OVR.setFormat(new BizDataFormat("$name$"));
        this.kdtEntrys.getColumn("position").setRenderer(kdtEntrys_position_OVR);
        final KDBizPromptBox kdtEntrys_adminOrg_PromptBox = new KDBizPromptBox();
        kdtEntrys_adminOrg_PromptBox.setQueryInfo("com.kingdee.eas.basedata.org.app.AdminItemQuery");
        kdtEntrys_adminOrg_PromptBox.setVisible(true);
        kdtEntrys_adminOrg_PromptBox.setEditable(true);
        kdtEntrys_adminOrg_PromptBox.setDisplayFormat("$number$");
        kdtEntrys_adminOrg_PromptBox.setEditFormat("$number$");
        kdtEntrys_adminOrg_PromptBox.setCommitFormat("$number$");
        KDTDefaultCellEditor kdtEntrys_adminOrg_CellEditor = new KDTDefaultCellEditor(kdtEntrys_adminOrg_PromptBox);
        this.kdtEntrys.getColumn("adminOrg").setEditor(kdtEntrys_adminOrg_CellEditor);
        ObjectValueRender kdtEntrys_adminOrg_OVR = new ObjectValueRender();
        kdtEntrys_adminOrg_OVR.setFormat(new BizDataFormat("$name$"));
        this.kdtEntrys.getColumn("adminOrg").setRenderer(kdtEntrys_adminOrg_OVR);
        KDDatePicker kdtEntrys_bizDate_DatePicker = new KDDatePicker();
        kdtEntrys_bizDate_DatePicker.setName("kdtEntrys_bizDate_DatePicker");
        kdtEntrys_bizDate_DatePicker.setVisible(true);
        kdtEntrys_bizDate_DatePicker.setEditable(true);
        KDTDefaultCellEditor kdtEntrys_bizDate_CellEditor = new KDTDefaultCellEditor(kdtEntrys_bizDate_DatePicker);
        this.kdtEntrys.getColumn("bizDate").setEditor(kdtEntrys_bizDate_CellEditor);
        KDTextField kdtEntrys_description_TextField = new KDTextField();
        kdtEntrys_description_TextField.setName("kdtEntrys_description_TextField");
        kdtEntrys_description_TextField.setMaxLength(200);
        KDTDefaultCellEditor kdtEntrys_description_CellEditor = new KDTDefaultCellEditor(kdtEntrys_description_TextField);
        this.kdtEntrys.getColumn("description").setEditor(kdtEntrys_description_CellEditor);
        KDTextField kdtEntrys_yearMonth_TextField = new KDTextField();
        kdtEntrys_yearMonth_TextField.setName("kdtEntrys_yearMonth_TextField");
        kdtEntrys_yearMonth_TextField.setMaxLength(100);
        KDTDefaultCellEditor kdtEntrys_yearMonth_CellEditor = new KDTDefaultCellEditor(kdtEntrys_yearMonth_TextField);
        this.kdtEntrys.getColumn("yearMonth").setEditor(kdtEntrys_yearMonth_CellEditor);
        KDDatePicker kdtEntrys_leaveDate_DatePicker = new KDDatePicker();
        kdtEntrys_leaveDate_DatePicker.setName("kdtEntrys_leaveDate_DatePicker");
        kdtEntrys_leaveDate_DatePicker.setVisible(true);
        kdtEntrys_leaveDate_DatePicker.setEditable(true);
        KDTDefaultCellEditor kdtEntrys_leaveDate_CellEditor = new KDTDefaultCellEditor(kdtEntrys_leaveDate_DatePicker);
        this.kdtEntrys.getColumn("leaveDate").setEditor(kdtEntrys_leaveDate_CellEditor);
        final KDBizPromptBox kdtEntrys_dormitory_PromptBox = new KDBizPromptBox();
        kdtEntrys_dormitory_PromptBox.setQueryInfo("com.kingdee.eas.custom.dormitorysystem.dormitory.app.DormitoryQuery");
        kdtEntrys_dormitory_PromptBox.setVisible(true);
        kdtEntrys_dormitory_PromptBox.setEditable(true);
        kdtEntrys_dormitory_PromptBox.setDisplayFormat("$number$");
        kdtEntrys_dormitory_PromptBox.setEditFormat("$number$");
        kdtEntrys_dormitory_PromptBox.setCommitFormat("$number$");
        KDTDefaultCellEditor kdtEntrys_dormitory_CellEditor = new KDTDefaultCellEditor(kdtEntrys_dormitory_PromptBox);
        this.kdtEntrys.getColumn("dormitory").setEditor(kdtEntrys_dormitory_CellEditor);
        ObjectValueRender kdtEntrys_dormitory_OVR = new ObjectValueRender();
        kdtEntrys_dormitory_OVR.setFormat(new BizDataFormat("$RoomNumber$"));
        this.kdtEntrys.getColumn("dormitory").setRenderer(kdtEntrys_dormitory_OVR);
        			kdtEntrys_dormitory_PromptBox.addSelectorListener(new SelectorListener() {
			com.kingdee.eas.custom.dormitorysystem.dormitory.client.DormitoryListUI kdtEntrys_dormitory_PromptBox_F7ListUI = null;
			public void willShow(SelectorEvent e) {
				if (kdtEntrys_dormitory_PromptBox_F7ListUI == null) {
					try {
						kdtEntrys_dormitory_PromptBox_F7ListUI = new com.kingdee.eas.custom.dormitorysystem.dormitory.client.DormitoryListUI();
					} catch (Exception e1) {
						e1.printStackTrace();
					}
					HashMap ctx = new HashMap();
					ctx.put("bizUIOwner",javax.swing.SwingUtilities.getWindowAncestor(kdtEntrys_dormitory_PromptBox_F7ListUI));
					kdtEntrys_dormitory_PromptBox_F7ListUI.setF7Use(true,ctx);
					kdtEntrys_dormitory_PromptBox.setSelector(kdtEntrys_dormitory_PromptBox_F7ListUI);
				}
			}
		});
					
        KDFormattedTextField kdtEntrys_waterTotalCost_TextField = new KDFormattedTextField();
        kdtEntrys_waterTotalCost_TextField.setName("kdtEntrys_waterTotalCost_TextField");
        kdtEntrys_waterTotalCost_TextField.setVisible(true);
        kdtEntrys_waterTotalCost_TextField.setEditable(true);
        kdtEntrys_waterTotalCost_TextField.setHorizontalAlignment(2);
        kdtEntrys_waterTotalCost_TextField.setDataType(1);
        	kdtEntrys_waterTotalCost_TextField.setMinimumValue(new java.math.BigDecimal("-1.0E18"));
        	kdtEntrys_waterTotalCost_TextField.setMaximumValue(new java.math.BigDecimal("1.0E18"));
        kdtEntrys_waterTotalCost_TextField.setPrecision(10);
        KDTDefaultCellEditor kdtEntrys_waterTotalCost_CellEditor = new KDTDefaultCellEditor(kdtEntrys_waterTotalCost_TextField);
        this.kdtEntrys.getColumn("waterTotalCost").setEditor(kdtEntrys_waterTotalCost_CellEditor);
        KDFormattedTextField kdtEntrys_electricityTotalCost_TextField = new KDFormattedTextField();
        kdtEntrys_electricityTotalCost_TextField.setName("kdtEntrys_electricityTotalCost_TextField");
        kdtEntrys_electricityTotalCost_TextField.setVisible(true);
        kdtEntrys_electricityTotalCost_TextField.setEditable(true);
        kdtEntrys_electricityTotalCost_TextField.setHorizontalAlignment(2);
        kdtEntrys_electricityTotalCost_TextField.setDataType(1);
        	kdtEntrys_electricityTotalCost_TextField.setMinimumValue(new java.math.BigDecimal("-1.0E18"));
        	kdtEntrys_electricityTotalCost_TextField.setMaximumValue(new java.math.BigDecimal("1.0E18"));
        kdtEntrys_electricityTotalCost_TextField.setPrecision(10);
        KDTDefaultCellEditor kdtEntrys_electricityTotalCost_CellEditor = new KDTDefaultCellEditor(kdtEntrys_electricityTotalCost_TextField);
        this.kdtEntrys.getColumn("electricityTotalCost").setEditor(kdtEntrys_electricityTotalCost_CellEditor);
        KDFormattedTextField kdtEntrys_monthWaterAmount_TextField = new KDFormattedTextField();
        kdtEntrys_monthWaterAmount_TextField.setName("kdtEntrys_monthWaterAmount_TextField");
        kdtEntrys_monthWaterAmount_TextField.setVisible(true);
        kdtEntrys_monthWaterAmount_TextField.setEditable(true);
        kdtEntrys_monthWaterAmount_TextField.setHorizontalAlignment(2);
        kdtEntrys_monthWaterAmount_TextField.setDataType(1);
        	kdtEntrys_monthWaterAmount_TextField.setMinimumValue(new java.math.BigDecimal("-1.0E18"));
        	kdtEntrys_monthWaterAmount_TextField.setMaximumValue(new java.math.BigDecimal("1.0E18"));
        kdtEntrys_monthWaterAmount_TextField.setPrecision(10);
        KDTDefaultCellEditor kdtEntrys_monthWaterAmount_CellEditor = new KDTDefaultCellEditor(kdtEntrys_monthWaterAmount_TextField);
        this.kdtEntrys.getColumn("monthWaterAmount").setEditor(kdtEntrys_monthWaterAmount_CellEditor);
        KDFormattedTextField kdtEntrys_monthElectricityAmount_TextField = new KDFormattedTextField();
        kdtEntrys_monthElectricityAmount_TextField.setName("kdtEntrys_monthElectricityAmount_TextField");
        kdtEntrys_monthElectricityAmount_TextField.setVisible(true);
        kdtEntrys_monthElectricityAmount_TextField.setEditable(true);
        kdtEntrys_monthElectricityAmount_TextField.setHorizontalAlignment(2);
        kdtEntrys_monthElectricityAmount_TextField.setDataType(1);
        	kdtEntrys_monthElectricityAmount_TextField.setMinimumValue(new java.math.BigDecimal("-1.0E18"));
        	kdtEntrys_monthElectricityAmount_TextField.setMaximumValue(new java.math.BigDecimal("1.0E18"));
        kdtEntrys_monthElectricityAmount_TextField.setPrecision(10);
        KDTDefaultCellEditor kdtEntrys_monthElectricityAmount_CellEditor = new KDTDefaultCellEditor(kdtEntrys_monthElectricityAmount_TextField);
        this.kdtEntrys.getColumn("monthElectricityAmount").setEditor(kdtEntrys_monthElectricityAmount_CellEditor);
        KDFormattedTextField kdtEntrys_monthDays_TextField = new KDFormattedTextField();
        kdtEntrys_monthDays_TextField.setName("kdtEntrys_monthDays_TextField");
        kdtEntrys_monthDays_TextField.setVisible(true);
        kdtEntrys_monthDays_TextField.setEditable(true);
        kdtEntrys_monthDays_TextField.setHorizontalAlignment(2);
        kdtEntrys_monthDays_TextField.setDataType(1);
        	kdtEntrys_monthDays_TextField.setMinimumValue(new java.math.BigDecimal("-1.0E18"));
        	kdtEntrys_monthDays_TextField.setMaximumValue(new java.math.BigDecimal("1.0E18"));
        kdtEntrys_monthDays_TextField.setPrecision(10);
        KDTDefaultCellEditor kdtEntrys_monthDays_CellEditor = new KDTDefaultCellEditor(kdtEntrys_monthDays_TextField);
        this.kdtEntrys.getColumn("monthDays").setEditor(kdtEntrys_monthDays_CellEditor);
        KDComboBox kdtEntrys_stutas_ComboBox = new KDComboBox();
        kdtEntrys_stutas_ComboBox.setName("kdtEntrys_stutas_ComboBox");
        kdtEntrys_stutas_ComboBox.setVisible(true);
        kdtEntrys_stutas_ComboBox.addItems(EnumUtils.getEnumList("com.kingdee.eas.custom.dormitorysystem.waterelectricity.WaterElectricityStutas").toArray());
        KDTDefaultCellEditor kdtEntrys_stutas_CellEditor = new KDTDefaultCellEditor(kdtEntrys_stutas_ComboBox);
        this.kdtEntrys.getColumn("stutas").setEditor(kdtEntrys_stutas_CellEditor);
        KDTextField kdtEntrys_positionStatus_TextField = new KDTextField();
        kdtEntrys_positionStatus_TextField.setName("kdtEntrys_positionStatus_TextField");
        kdtEntrys_positionStatus_TextField.setMaxLength(100);
        KDTDefaultCellEditor kdtEntrys_positionStatus_CellEditor = new KDTDefaultCellEditor(kdtEntrys_positionStatus_TextField);
        this.kdtEntrys.getColumn("positionStatus").setEditor(kdtEntrys_positionStatus_CellEditor);
        KDDatePicker kdtEntrys_startDate_DatePicker = new KDDatePicker();
        kdtEntrys_startDate_DatePicker.setName("kdtEntrys_startDate_DatePicker");
        kdtEntrys_startDate_DatePicker.setVisible(true);
        kdtEntrys_startDate_DatePicker.setEditable(true);
        KDTDefaultCellEditor kdtEntrys_startDate_CellEditor = new KDTDefaultCellEditor(kdtEntrys_startDate_DatePicker);
        this.kdtEntrys.getColumn("startDate").setEditor(kdtEntrys_startDate_CellEditor);
        KDDatePicker kdtEntrys_endDate_DatePicker = new KDDatePicker();
        kdtEntrys_endDate_DatePicker.setName("kdtEntrys_endDate_DatePicker");
        kdtEntrys_endDate_DatePicker.setVisible(true);
        kdtEntrys_endDate_DatePicker.setEditable(true);
        KDTDefaultCellEditor kdtEntrys_endDate_CellEditor = new KDTDefaultCellEditor(kdtEntrys_endDate_DatePicker);
        this.kdtEntrys.getColumn("endDate").setEditor(kdtEntrys_endDate_CellEditor);
        // contApplier		
        this.contApplier.setBoundLabelText(resHelper.getString("contApplier.boundLabelText"));		
        this.contApplier.setBoundLabelLength(90);		
        this.contApplier.setBoundLabelUnderline(true);		
        this.contApplier.setBoundLabelAlignment(7);		
        this.contApplier.setVisible(true);
        // contAdminOrg		
        this.contAdminOrg.setBoundLabelText(resHelper.getString("contAdminOrg.boundLabelText"));		
        this.contAdminOrg.setBoundLabelLength(90);		
        this.contAdminOrg.setBoundLabelUnderline(true);		
        this.contAdminOrg.setBoundLabelAlignment(7);		
        this.contAdminOrg.setVisible(true);
        // contApplyDate		
        this.contApplyDate.setBoundLabelText(resHelper.getString("contApplyDate.boundLabelText"));		
        this.contApplyDate.setBoundLabelLength(90);		
        this.contApplyDate.setBoundLabelUnderline(true);		
        this.contApplyDate.setBoundLabelAlignment(7);		
        this.contApplyDate.setVisible(true);
        // contBillState		
        this.contBillState.setBoundLabelText(resHelper.getString("contBillState.boundLabelText"));		
        this.contBillState.setBoundLabelLength(90);		
        this.contBillState.setBoundLabelUnderline(true);		
        this.contBillState.setBoundLabelAlignment(7);		
        this.contBillState.setVisible(false);
        // contyearMonth		
        this.contyearMonth.setBoundLabelText(resHelper.getString("contyearMonth.boundLabelText"));		
        this.contyearMonth.setBoundLabelLength(100);		
        this.contyearMonth.setBoundLabelUnderline(true);		
        this.contyearMonth.setVisible(true);
        // contperson		
        this.contperson.setBoundLabelText(resHelper.getString("contperson.boundLabelText"));		
        this.contperson.setBoundLabelLength(100);		
        this.contperson.setBoundLabelUnderline(true);		
        this.contperson.setVisible(true);
        // contempName		
        this.contempName.setBoundLabelText(resHelper.getString("contempName.boundLabelText"));		
        this.contempName.setBoundLabelLength(100);		
        this.contempName.setBoundLabelUnderline(true);		
        this.contempName.setVisible(true);
        // contempNumber		
        this.contempNumber.setBoundLabelText(resHelper.getString("contempNumber.boundLabelText"));		
        this.contempNumber.setBoundLabelLength(100);		
        this.contempNumber.setBoundLabelUnderline(true);		
        this.contempNumber.setVisible(true);
        // contpositionStatus		
        this.contpositionStatus.setBoundLabelText(resHelper.getString("contpositionStatus.boundLabelText"));		
        this.contpositionStatus.setBoundLabelLength(100);		
        this.contpositionStatus.setBoundLabelUnderline(true);		
        this.contpositionStatus.setVisible(true);
        // contleaveDate		
        this.contleaveDate.setBoundLabelText(resHelper.getString("contleaveDate.boundLabelText"));		
        this.contleaveDate.setBoundLabelLength(100);		
        this.contleaveDate.setBoundLabelUnderline(true);		
        this.contleaveDate.setVisible(true);
        // contdormitory		
        this.contdormitory.setBoundLabelText(resHelper.getString("contdormitory.boundLabelText"));		
        this.contdormitory.setBoundLabelLength(100);		
        this.contdormitory.setBoundLabelUnderline(true);		
        this.contdormitory.setVisible(true);
        // contwaterTotalCost		
        this.contwaterTotalCost.setBoundLabelText(resHelper.getString("contwaterTotalCost.boundLabelText"));		
        this.contwaterTotalCost.setBoundLabelLength(100);		
        this.contwaterTotalCost.setBoundLabelUnderline(true);		
        this.contwaterTotalCost.setVisible(true);
        // contelectricityTotalCost		
        this.contelectricityTotalCost.setBoundLabelText(resHelper.getString("contelectricityTotalCost.boundLabelText"));		
        this.contelectricityTotalCost.setBoundLabelLength(100);		
        this.contelectricityTotalCost.setBoundLabelUnderline(true);		
        this.contelectricityTotalCost.setVisible(true);
        // contmonthWaterAmount		
        this.contmonthWaterAmount.setBoundLabelText(resHelper.getString("contmonthWaterAmount.boundLabelText"));		
        this.contmonthWaterAmount.setBoundLabelLength(100);		
        this.contmonthWaterAmount.setBoundLabelUnderline(true);		
        this.contmonthWaterAmount.setVisible(true);
        // contmonthElectricityAmount		
        this.contmonthElectricityAmount.setBoundLabelText(resHelper.getString("contmonthElectricityAmount.boundLabelText"));		
        this.contmonthElectricityAmount.setBoundLabelLength(100);		
        this.contmonthElectricityAmount.setBoundLabelUnderline(true);		
        this.contmonthElectricityAmount.setVisible(true);
        // contmonthDays		
        this.contmonthDays.setBoundLabelText(resHelper.getString("contmonthDays.boundLabelText"));		
        this.contmonthDays.setBoundLabelLength(100);		
        this.contmonthDays.setBoundLabelUnderline(true);		
        this.contmonthDays.setVisible(true);
        // contstutas		
        this.contstutas.setBoundLabelText(resHelper.getString("contstutas.boundLabelText"));		
        this.contstutas.setBoundLabelLength(100);		
        this.contstutas.setBoundLabelUnderline(true);		
        this.contstutas.setVisible(true);
        // contmeterReading		
        this.contmeterReading.setBoundLabelText(resHelper.getString("contmeterReading.boundLabelText"));		
        this.contmeterReading.setBoundLabelLength(100);		
        this.contmeterReading.setBoundLabelUnderline(true);		
        this.contmeterReading.setVisible(true);
        // conthydropowerStandards		
        this.conthydropowerStandards.setBoundLabelText(resHelper.getString("conthydropowerStandards.boundLabelText"));		
        this.conthydropowerStandards.setBoundLabelLength(100);		
        this.conthydropowerStandards.setBoundLabelUnderline(true);		
        this.conthydropowerStandards.setVisible(true);
        // contposition		
        this.contposition.setBoundLabelText(resHelper.getString("contposition.boundLabelText"));		
        this.contposition.setBoundLabelLength(100);		
        this.contposition.setBoundLabelUnderline(true);		
        this.contposition.setVisible(true);
        // contstartDate		
        this.contstartDate.setBoundLabelText(resHelper.getString("contstartDate.boundLabelText"));		
        this.contstartDate.setBoundLabelLength(100);		
        this.contstartDate.setBoundLabelUnderline(true);		
        this.contstartDate.setVisible(true);
        // contendDate		
        this.contendDate.setBoundLabelText(resHelper.getString("contendDate.boundLabelText"));		
        this.contendDate.setBoundLabelLength(100);		
        this.contendDate.setBoundLabelUnderline(true);		
        this.contendDate.setVisible(true);
        // contallMonthDays		
        this.contallMonthDays.setBoundLabelText(resHelper.getString("contallMonthDays.boundLabelText"));		
        this.contallMonthDays.setBoundLabelLength(100);		
        this.contallMonthDays.setBoundLabelUnderline(true);		
        this.contallMonthDays.setVisible(true);
        // txtNumber		
        this.txtNumber.setMaxLength(80);		
        this.txtNumber.setRequired(true);		
        this.txtNumber.setVisible(true);		
        this.txtNumber.setEnabled(true);		
        this.txtNumber.setHorizontalAlignment(2);
        // txtDescription		
        this.txtDescription.setMaxLength(200);		
        this.txtDescription.setVisible(true);		
        this.txtDescription.setEnabled(true);		
        this.txtDescription.setHorizontalAlignment(2);		
        this.txtDescription.setRequired(false);
        // txtApplier		
        this.txtApplier.setEnabled(false);		
        this.txtApplier.setMaxLength(80);		
        this.txtApplier.setVisible(true);		
        this.txtApplier.setHorizontalAlignment(2);		
        this.txtApplier.setRequired(false);
        // prmtAdminOrg		
        this.prmtAdminOrg.setRequired(true);		
        this.prmtAdminOrg.setVisible(true);		
        this.prmtAdminOrg.setEnabled(true);
        // dpApplyDate		
        this.dpApplyDate.setEnabled(false);		
        this.dpApplyDate.setVisible(true);		
        this.dpApplyDate.setRequired(false);
        // cbBillState		
        this.cbBillState.addItems(EnumUtils.getEnumList("com.kingdee.eas.hr.base.HRBillStateEnum").toArray());		
        this.cbBillState.setEnabled(false);		
        this.cbBillState.setVisible(false);		
        this.cbBillState.setRequired(false);
        // txtyearMonth		
        this.txtyearMonth.setVisible(true);		
        this.txtyearMonth.setHorizontalAlignment(2);		
        this.txtyearMonth.setMaxLength(100);		
        this.txtyearMonth.setRequired(false);
        // prmtperson		
        this.prmtperson.setQueryInfo("com.kingdee.eas.basedata.person.app.PersonQuery");		
        this.prmtperson.setVisible(true);		
        this.prmtperson.setEditable(true);		
        this.prmtperson.setDisplayFormat("$name$");		
        this.prmtperson.setEditFormat("$number$");		
        this.prmtperson.setCommitFormat("$number$");		
        this.prmtperson.setRequired(false);
        // txtempName		
        this.txtempName.setVisible(true);		
        this.txtempName.setHorizontalAlignment(2);		
        this.txtempName.setMaxLength(100);		
        this.txtempName.setRequired(false);
        // txtempNumber		
        this.txtempNumber.setVisible(true);		
        this.txtempNumber.setHorizontalAlignment(2);		
        this.txtempNumber.setMaxLength(100);		
        this.txtempNumber.setRequired(false);
        // txtpositionStatus		
        this.txtpositionStatus.setVisible(true);		
        this.txtpositionStatus.setHorizontalAlignment(2);		
        this.txtpositionStatus.setMaxLength(100);		
        this.txtpositionStatus.setRequired(false);
        // pkleaveDate		
        this.pkleaveDate.setVisible(true);		
        this.pkleaveDate.setRequired(false);
        // prmtdormitory		
        this.prmtdormitory.setQueryInfo("com.kingdee.eas.custom.dormitorysystem.dormitory.app.DormitoryQuery");		
        this.prmtdormitory.setVisible(true);		
        this.prmtdormitory.setEditable(true);		
        this.prmtdormitory.setDisplayFormat("$RoomNumber$");		
        this.prmtdormitory.setEditFormat("$number$");		
        this.prmtdormitory.setCommitFormat("$number$");		
        this.prmtdormitory.setRequired(false);
        		prmtdormitory.addSelectorListener(new SelectorListener() {
			com.kingdee.eas.custom.dormitorysystem.dormitory.client.DormitoryListUI prmtdormitory_F7ListUI = null;
			public void willShow(SelectorEvent e) {
				if (prmtdormitory_F7ListUI == null) {
					try {
						prmtdormitory_F7ListUI = new com.kingdee.eas.custom.dormitorysystem.dormitory.client.DormitoryListUI();
					} catch (Exception e1) {
						e1.printStackTrace();
					}
					HashMap ctx = new HashMap();
					ctx.put("bizUIOwner",javax.swing.SwingUtilities.getWindowAncestor(prmtdormitory_F7ListUI));
					prmtdormitory_F7ListUI.setF7Use(true,ctx);
					prmtdormitory.setSelector(prmtdormitory_F7ListUI);
				}
			}
		});
					
        // txtwaterTotalCost		
        this.txtwaterTotalCost.setVisible(true);		
        this.txtwaterTotalCost.setHorizontalAlignment(2);		
        this.txtwaterTotalCost.setDataType(1);		
        this.txtwaterTotalCost.setSupportedEmpty(true);		
        this.txtwaterTotalCost.setMinimumValue( new java.math.BigDecimal("-1.0E18"));		
        this.txtwaterTotalCost.setMaximumValue( new java.math.BigDecimal("1.0E18"));		
        this.txtwaterTotalCost.setPrecision(2);		
        this.txtwaterTotalCost.setRequired(false);
        // txtelectricityTotalCost		
        this.txtelectricityTotalCost.setVisible(true);		
        this.txtelectricityTotalCost.setHorizontalAlignment(2);		
        this.txtelectricityTotalCost.setDataType(1);		
        this.txtelectricityTotalCost.setSupportedEmpty(true);		
        this.txtelectricityTotalCost.setMinimumValue( new java.math.BigDecimal("-1.0E18"));		
        this.txtelectricityTotalCost.setMaximumValue( new java.math.BigDecimal("1.0E18"));		
        this.txtelectricityTotalCost.setPrecision(2);		
        this.txtelectricityTotalCost.setRequired(false);
        // txtmonthWaterAmount		
        this.txtmonthWaterAmount.setVisible(true);		
        this.txtmonthWaterAmount.setHorizontalAlignment(2);		
        this.txtmonthWaterAmount.setDataType(1);		
        this.txtmonthWaterAmount.setSupportedEmpty(true);		
        this.txtmonthWaterAmount.setMinimumValue( new java.math.BigDecimal("-1.0E18"));		
        this.txtmonthWaterAmount.setMaximumValue( new java.math.BigDecimal("1.0E18"));		
        this.txtmonthWaterAmount.setPrecision(2);		
        this.txtmonthWaterAmount.setRequired(false);
        // txtmonthElectricityAmount		
        this.txtmonthElectricityAmount.setVisible(true);		
        this.txtmonthElectricityAmount.setHorizontalAlignment(2);		
        this.txtmonthElectricityAmount.setDataType(1);		
        this.txtmonthElectricityAmount.setSupportedEmpty(true);		
        this.txtmonthElectricityAmount.setMinimumValue( new java.math.BigDecimal("-1.0E18"));		
        this.txtmonthElectricityAmount.setMaximumValue( new java.math.BigDecimal("1.0E18"));		
        this.txtmonthElectricityAmount.setPrecision(2);		
        this.txtmonthElectricityAmount.setRequired(false);
        // txtmonthDays		
        this.txtmonthDays.setVisible(true);		
        this.txtmonthDays.setHorizontalAlignment(2);		
        this.txtmonthDays.setDataType(1);		
        this.txtmonthDays.setSupportedEmpty(true);		
        this.txtmonthDays.setMinimumValue( new java.math.BigDecimal("-1.0E18"));		
        this.txtmonthDays.setMaximumValue( new java.math.BigDecimal("1.0E18"));		
        this.txtmonthDays.setPrecision(2);		
        this.txtmonthDays.setRequired(false);
        // stutas		
        this.stutas.setVisible(true);		
        this.stutas.addItems(EnumUtils.getEnumList("com.kingdee.eas.custom.dormitorysystem.waterelectricity.WaterElectricityStutas").toArray());		
        this.stutas.setRequired(false);
        // scrollPanemeterReading
        // txtmeterReading		
        this.txtmeterReading.setVisible(true);		
        this.txtmeterReading.setRequired(false);		
        this.txtmeterReading.setMaxLength(180);
        // scrollPanehydropowerStandards
        // txthydropowerStandards		
        this.txthydropowerStandards.setVisible(true);		
        this.txthydropowerStandards.setRequired(false);		
        this.txthydropowerStandards.setMaxLength(180);
        // prmtposition		
        this.prmtposition.setQueryInfo("com.kingdee.eas.hr.org.app.PositionHRListQuery");		
        this.prmtposition.setVisible(true);		
        this.prmtposition.setEditable(true);		
        this.prmtposition.setDisplayFormat("$name$");		
        this.prmtposition.setEditFormat("$number$");		
        this.prmtposition.setCommitFormat("$number$");		
        this.prmtposition.setRequired(false);
        // pkstartDate		
        this.pkstartDate.setVisible(true);		
        this.pkstartDate.setRequired(false);
        // pkendDate		
        this.pkendDate.setVisible(true);		
        this.pkendDate.setRequired(false);
        // txtallMonthDays		
        this.txtallMonthDays.setVisible(true);		
        this.txtallMonthDays.setHorizontalAlignment(2);		
        this.txtallMonthDays.setDataType(1);		
        this.txtallMonthDays.setSupportedEmpty(true);		
        this.txtallMonthDays.setMinimumValue( new java.math.BigDecimal("-1.0E18"));		
        this.txtallMonthDays.setMaximumValue( new java.math.BigDecimal("1.0E18"));		
        this.txtallMonthDays.setPrecision(2);		
        this.txtallMonthDays.setRequired(false);
        this.setFocusTraversalPolicy(new com.kingdee.bos.ui.UIFocusTraversalPolicy(new java.awt.Component[] {txtApplier,txtDescription,txtNumber,cbBillState,prmtAdminOrg,dpApplyDate,kdtEntrys,txtyearMonth,prmtperson,txtempName,txtempNumber,txtpositionStatus,pkleaveDate,prmtdormitory,txtwaterTotalCost,txtelectricityTotalCost,txtmonthWaterAmount,txtmonthElectricityAmount,txtmonthDays,stutas,txtmeterReading,txthydropowerStandards,cbApproveType,prmtHROrg,prmtposition,pkstartDate,pkendDate,txtallMonthDays}));
        this.setFocusCycleRoot(true);
		//Register control's property binding
		registerBindings();
		registerUIState();


    }

	public com.kingdee.bos.ctrl.swing.KDToolBar[] getUIMultiToolBar(){
		java.util.List list = new java.util.ArrayList();
		com.kingdee.bos.ctrl.swing.KDToolBar[] bars = super.getUIMultiToolBar();
		if (bars != null) {
			list.addAll(java.util.Arrays.asList(bars));
		}
		return (com.kingdee.bos.ctrl.swing.KDToolBar[])list.toArray(new com.kingdee.bos.ctrl.swing.KDToolBar[list.size()]);
	}




    /**
     * output initUIContentLayout method
     */
    public void initUIContentLayout()
    {
        this.setBounds(new Rectangle(0, 0, 1013, 629));
        this.setLayout(new KDLayout());
        this.putClientProperty("OriginalBounds", new Rectangle(0, 0, 1013, 629));
        contHROrg.setBounds(new Rectangle(10, 10, 270, 19));
        this.add(contHROrg, new KDLayout.Constraints(10, 10, 270, 19, KDLayout.Constraints.ANCHOR_TOP | KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contApproveType.setBounds(new Rectangle(732, 54, 270, 19));
        this.add(contApproveType, new KDLayout.Constraints(732, 54, 270, 19, KDLayout.Constraints.ANCHOR_TOP | KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contNumber.setBounds(new Rectangle(10, 32, 270, 19));
        this.add(contNumber, new KDLayout.Constraints(10, 32, 270, 19, KDLayout.Constraints.ANCHOR_TOP | KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contDescription.setBounds(new Rectangle(376, 54, 270, 19));
        this.add(contDescription, new KDLayout.Constraints(376, 54, 270, 19, KDLayout.Constraints.ANCHOR_TOP | KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        kdtEntrys.setBounds(new Rectangle(10, 76, 993, 543));
        kdtEntrys_detailPanel = (com.kingdee.eas.framework.client.multiDetail.DetailPanel)com.kingdee.eas.framework.client.multiDetail.HMDUtils.buildDetail(this,dataBinder,kdtEntrys,new com.kingdee.eas.custom.dormitorysystem.waterelectricity.WaterElectricityEntryInfo(),null,false);
        this.add(kdtEntrys_detailPanel, new KDLayout.Constraints(10, 76, 993, 543, KDLayout.Constraints.ANCHOR_TOP | KDLayout.Constraints.ANCHOR_BOTTOM | KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT));
		kdtEntrys_detailPanel.addAddListener(new com.kingdee.eas.framework.client.multiDetail.IDetailPanelListener() {
			public void beforeEvent(com.kingdee.eas.framework.client.multiDetail.DetailPanelEvent event) throws Exception {
				IObjectValue vo = event.getObjectValue();
vo.put("stutas","Lock");
			}
			public void afterEvent(com.kingdee.eas.framework.client.multiDetail.DetailPanelEvent event) throws Exception {
			}
		});
        contApplier.setBounds(new Rectangle(10, 54, 270, 19));
        this.add(contApplier, new KDLayout.Constraints(10, 54, 270, 19, KDLayout.Constraints.ANCHOR_TOP | KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contAdminOrg.setBounds(new Rectangle(376, 32, 270, 19));
        this.add(contAdminOrg, new KDLayout.Constraints(376, 32, 270, 19, KDLayout.Constraints.ANCHOR_TOP | KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contApplyDate.setBounds(new Rectangle(732, 32, 270, 19));
        this.add(contApplyDate, new KDLayout.Constraints(732, 32, 270, 19, KDLayout.Constraints.ANCHOR_TOP | KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contBillState.setBounds(new Rectangle(732, 10, 270, 19));
        this.add(contBillState, new KDLayout.Constraints(732, 10, 270, 19, KDLayout.Constraints.ANCHOR_TOP | KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contyearMonth.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contyearMonth, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contperson.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contperson, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contempName.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contempName, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contempNumber.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contempNumber, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contpositionStatus.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contpositionStatus, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contleaveDate.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contleaveDate, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contdormitory.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contdormitory, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contwaterTotalCost.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contwaterTotalCost, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contelectricityTotalCost.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contelectricityTotalCost, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contmonthWaterAmount.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contmonthWaterAmount, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contmonthElectricityAmount.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contmonthElectricityAmount, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contmonthDays.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contmonthDays, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contstutas.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contstutas, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contmeterReading.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contmeterReading, new KDLayout.Constraints(0, 0, 270, 19, 0));
        conthydropowerStandards.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(conthydropowerStandards, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contposition.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contposition, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contstartDate.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contstartDate, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contendDate.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contendDate, new KDLayout.Constraints(0, 0, 270, 19, 0));
        contallMonthDays.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contallMonthDays, new KDLayout.Constraints(0, 0, 270, 19, 0));
        //contHROrg
        contHROrg.setBoundEditor(prmtHROrg);
        //contApproveType
        contApproveType.setBoundEditor(cbApproveType);
        //contNumber
        contNumber.setBoundEditor(txtNumber);
        //contDescription
        contDescription.setBoundEditor(txtDescription);
        //contApplier
        contApplier.setBoundEditor(txtApplier);
        //contAdminOrg
        contAdminOrg.setBoundEditor(prmtAdminOrg);
        //contApplyDate
        contApplyDate.setBoundEditor(dpApplyDate);
        //contBillState
        contBillState.setBoundEditor(cbBillState);
        //contyearMonth
        contyearMonth.setBoundEditor(txtyearMonth);
        //contperson
        contperson.setBoundEditor(prmtperson);
        //contempName
        contempName.setBoundEditor(txtempName);
        //contempNumber
        contempNumber.setBoundEditor(txtempNumber);
        //contpositionStatus
        contpositionStatus.setBoundEditor(txtpositionStatus);
        //contleaveDate
        contleaveDate.setBoundEditor(pkleaveDate);
        //contdormitory
        contdormitory.setBoundEditor(prmtdormitory);
        //contwaterTotalCost
        contwaterTotalCost.setBoundEditor(txtwaterTotalCost);
        //contelectricityTotalCost
        contelectricityTotalCost.setBoundEditor(txtelectricityTotalCost);
        //contmonthWaterAmount
        contmonthWaterAmount.setBoundEditor(txtmonthWaterAmount);
        //contmonthElectricityAmount
        contmonthElectricityAmount.setBoundEditor(txtmonthElectricityAmount);
        //contmonthDays
        contmonthDays.setBoundEditor(txtmonthDays);
        //contstutas
        contstutas.setBoundEditor(stutas);
        //contmeterReading
        contmeterReading.setBoundEditor(scrollPanemeterReading);
        //scrollPanemeterReading
        scrollPanemeterReading.getViewport().add(txtmeterReading, null);
        //conthydropowerStandards
        conthydropowerStandards.setBoundEditor(scrollPanehydropowerStandards);
        //scrollPanehydropowerStandards
        scrollPanehydropowerStandards.getViewport().add(txthydropowerStandards, null);
        //contposition
        contposition.setBoundEditor(prmtposition);
        //contstartDate
        contstartDate.setBoundEditor(pkstartDate);
        //contendDate
        contendDate.setBoundEditor(pkendDate);
        //contallMonthDays
        contallMonthDays.setBoundEditor(txtallMonthDays);

    }


    /**
     * output initUIMenuBarLayout method
     */
    public void initUIMenuBarLayout()
    {
        this.menuBar.add(menuFile);
        this.menuBar.add(menuEdit);
        this.menuBar.add(MenuService);
        this.menuBar.add(menuView);
        this.menuBar.add(menuBiz);
        this.menuBar.add(menuTable1);
        this.menuBar.add(menuTool);
        this.menuBar.add(menuWorkflow);
        this.menuBar.add(menuHelp);
        //menuFile
        menuFile.add(menuItemAddNew);
        menuFile.add(kDSeparator1);
        menuFile.add(menuItemCloudFeed);
        menuFile.add(menuItemSave);
        menuFile.add(menuItemCloudScreen);
        menuFile.add(menuItemSubmit);
        menuFile.add(menuItemCloudShare);
        menuFile.add(menuSubmitOption);
        menuFile.add(kdSeparatorFWFile1);
        menuFile.add(rMenuItemSubmit);
        menuFile.add(rMenuItemSubmitAndAddNew);
        menuFile.add(rMenuItemSubmitAndPrint);
        menuFile.add(separatorFile1);
        menuFile.add(menuItemMapping);
        menuFile.add(MenuItemAttachment);
        menuFile.add(kDSeparator2);
        menuFile.add(menuItemPageSetup);
        menuFile.add(menuItemPrint);
        menuFile.add(menuItemPrintPreview);
        menuFile.add(kDSeparator6);
        menuFile.add(kDSeparator3);
        menuFile.add(menuItemSendMail);
        menuFile.add(menuItemExitCurrent);
        //menuSubmitOption
        menuSubmitOption.add(chkMenuItemSubmitAndAddNew);
        menuSubmitOption.add(chkMenuItemSubmitAndPrint);
        //menuEdit
        menuEdit.add(menuItemCopy);
        menuEdit.add(menuItemEdit);
        menuEdit.add(menuItemRemove);
        menuEdit.add(kDSeparator4);
        menuEdit.add(menuItemReset);
        menuEdit.add(separator1);
        menuEdit.add(menuItemCreateFrom);
        menuEdit.add(menuItemCreateTo);
        menuEdit.add(menuItemCopyFrom);
        menuEdit.add(menuItemColumnCopyAll);
        menuEdit.add(menuItemEnterToNextRow);
        menuEdit.add(menuItemColumnCopySelect);
        menuEdit.add(separatorEdit1);
        menuEdit.add(separator2);
        //MenuService
        MenuService.add(MenuItemKnowStore);
        MenuService.add(MenuItemAnwser);
        MenuService.add(SepratorService);
        MenuService.add(MenuItemRemoteAssist);
        //menuView
        menuView.add(menuItemFirst);
        menuView.add(menuItemPre);
        menuView.add(menuItemNext);
        menuView.add(menuItemLast);
        menuView.add(separator3);
        menuView.add(menuItemTraceUp);
        menuView.add(menuItemTraceDown);
        menuView.add(kDSeparator7);
        menuView.add(menuItemLocate);
        //menuBiz
        menuBiz.add(menuItemCancelCancel);
        menuBiz.add(menuItemCancel);
        menuBiz.add(MenuItemVoucher);
        menuBiz.add(menuItemDelVoucher);
        menuBiz.add(MenuItemPCVoucher);
        menuBiz.add(menuItemAudit);
        menuBiz.add(menuItemDelPCVoucher);
        menuBiz.add(menuItemUnaudit);
        menuBiz.add(menuItemPerson);
        //menuTable1
        menuTable1.add(menuItemAddLine);
        menuTable1.add(menuItemCopyLine);
        menuTable1.add(menuItemInsertLine);
        menuTable1.add(menuItemRemoveLine);
        //menuTool
        menuTool.add(menuItemSendMessage);
        menuTool.add(menuItemMsgFormat);
        menuTool.add(menuItemCalculator);
        menuTool.add(menuItemToolBarCustom);
        //menuWorkflow
        menuWorkflow.add(menuItemStartWorkFlow);
        menuWorkflow.add(separatorWF1);
        menuWorkflow.add(menuItemViewSubmitProccess);
        menuWorkflow.add(menuItemViewDoProccess);
        menuWorkflow.add(MenuItemWFG);
        menuWorkflow.add(menuItemWorkFlowList);
        menuWorkflow.add(separatorWF2);
        menuWorkflow.add(menuItemMultiapprove);
        menuWorkflow.add(menuItemNextPerson);
        menuWorkflow.add(menuItemAuditResult);
        menuWorkflow.add(kDSeparator5);
        menuWorkflow.add(kDMenuItemSendMessage);
        //menuHelp
        menuHelp.add(menuItemHelp);
        menuHelp.add(kDSeparator12);
        menuHelp.add(menuItemRegPro);
        menuHelp.add(menuItemPersonalSite);
        menuHelp.add(helpseparatorDiv);
        menuHelp.add(menuitemProductval);
        menuHelp.add(kDSeparatorProduct);
        menuHelp.add(menuItemAbout);

    }

    /**
     * output initUIToolBarLayout method
     */
    public void initUIToolBarLayout()
    {
        this.toolBar.add(btnAddNew);
        this.toolBar.add(btnCloud);
        this.toolBar.add(btnEdit);
        this.toolBar.add(btnSave);
        this.toolBar.add(btnXunTong);
        this.toolBar.add(btnReset);
        this.toolBar.add(btnSubmit);
        this.toolBar.add(kDSeparatorCloud);
        this.toolBar.add(btnCopy);
        this.toolBar.add(btnRemove);
        this.toolBar.add(btnCancelCancel);
        this.toolBar.add(btnCancel);
        this.toolBar.add(btnAttachment);
        this.toolBar.add(separatorFW1);
        this.toolBar.add(btnPageSetup);
        this.toolBar.add(btnColumnCopyAll);
        this.toolBar.add(btnPrint);
        this.toolBar.add(btnColumnCopySelect);
        this.toolBar.add(btnPrintPreview);
        this.toolBar.add(separatorFW2);
        this.toolBar.add(btnFirst);
        this.toolBar.add(btnPre);
        this.toolBar.add(btnNext);
        this.toolBar.add(btnLast);
        this.toolBar.add(separatorFW3);
        this.toolBar.add(btnTraceUp);
        this.toolBar.add(btnTraceDown);
        this.toolBar.add(btnWorkFlowG);
        this.toolBar.add(btnSignature);
        this.toolBar.add(btnViewSignature);
        this.toolBar.add(separatorFW4);
        this.toolBar.add(separatorFW7);
        this.toolBar.add(btnCreateFrom);
        this.toolBar.add(btnCopyFrom);
        this.toolBar.add(btnNumberSign);
        this.toolBar.add(btnCreateTo);
        this.toolBar.add(separatorFW5);
        this.toolBar.add(separatorFW8);
        this.toolBar.add(btnAddLine);
        this.toolBar.add(btnInsertLine);
        this.toolBar.add(btnRemoveLine);
        this.toolBar.add(separatorFW6);
        this.toolBar.add(separatorFW9);
        this.toolBar.add(btnCopyLine);
        this.toolBar.add(btnVoucher);
        this.toolBar.add(btnDelVoucher);
        this.toolBar.add(btnAuditResult);
        this.toolBar.add(btnMultiapprove);
        this.toolBar.add(btnWFViewdoProccess);
        this.toolBar.add(btnWFViewSubmitProccess);
        this.toolBar.add(btnNextPerson);
        this.toolBar.add(btnPCVoucher);
        this.toolBar.add(btnAudit);
        this.toolBar.add(btnDelPCVoucher);
        this.toolBar.add(btnUnaudit);
        this.toolBar.add(btnPerson);


    }

	//Regiester control's property binding.
	private void registerBindings(){
		dataBinder.registerBinding("hrOrgUnit", com.kingdee.eas.basedata.org.HROrgUnitInfo.class, this.prmtHROrg, "data");
		dataBinder.registerBinding("approveType", com.kingdee.eas.hr.base.ApproveTypeEnum.class, this.cbApproveType, "selectedItem");
		dataBinder.registerBinding("entrys.id", com.kingdee.bos.util.BOSUuid.class, this.kdtEntrys, "id.text");
		dataBinder.registerBinding("entrys", com.kingdee.eas.custom.dormitorysystem.waterelectricity.WaterElectricityEntryInfo.class, this.kdtEntrys, "userObject");
		dataBinder.registerBinding("entrys.bizDate", java.util.Date.class, this.kdtEntrys, "bizDate.text");
		dataBinder.registerBinding("entrys.description", String.class, this.kdtEntrys, "description.text");
		dataBinder.registerBinding("entrys.person", com.kingdee.eas.basedata.person.PersonInfo.class, this.kdtEntrys, "person.text");
		dataBinder.registerBinding("entrys.person.number", String.class, this.kdtEntrys, "empNumber.text");
		dataBinder.registerBinding("entrys.person.name", String.class, this.kdtEntrys, "empName.text");
		dataBinder.registerBinding("entrys.position", com.kingdee.eas.basedata.org.PositionInfo.class, this.kdtEntrys, "position.text");
		dataBinder.registerBinding("entrys.adminOrg", com.kingdee.eas.basedata.org.AdminOrgUnitInfo.class, this.kdtEntrys, "adminOrg.text");
		dataBinder.registerBinding("entrys.yearMonth", String.class, this.kdtEntrys, "yearMonth.text");
		dataBinder.registerBinding("entrys.leaveDate", java.util.Date.class, this.kdtEntrys, "leaveDate.text");
		dataBinder.registerBinding("entrys.dormitory", java.lang.Object.class, this.kdtEntrys, "dormitory.text");
		dataBinder.registerBinding("entrys.waterTotalCost", java.math.BigDecimal.class, this.kdtEntrys, "waterTotalCost.text");
		dataBinder.registerBinding("entrys.electricityTotalCost", java.math.BigDecimal.class, this.kdtEntrys, "electricityTotalCost.text");
		dataBinder.registerBinding("entrys.monthWaterAmount", java.math.BigDecimal.class, this.kdtEntrys, "monthWaterAmount.text");
		dataBinder.registerBinding("entrys.monthElectricityAmount", java.math.BigDecimal.class, this.kdtEntrys, "monthElectricityAmount.text");
		dataBinder.registerBinding("entrys.monthDays", java.math.BigDecimal.class, this.kdtEntrys, "monthDays.text");
		dataBinder.registerBinding("entrys.stutas", com.kingdee.util.enums.Enum.class, this.kdtEntrys, "stutas.text");
		dataBinder.registerBinding("entrys.positionStatus", String.class, this.kdtEntrys, "positionStatus.text");
		dataBinder.registerBinding("entrys.startDate", java.util.Date.class, this.kdtEntrys, "startDate.text");
		dataBinder.registerBinding("entrys.endDate", java.util.Date.class, this.kdtEntrys, "endDate.text");
		dataBinder.registerBinding("number", String.class, this.txtNumber, "text");
		dataBinder.registerBinding("description", String.class, this.txtDescription, "text");
		dataBinder.registerBinding("applier.name", String.class, this.txtApplier, "text");
		dataBinder.registerBinding("adminOrg", com.kingdee.eas.basedata.org.AdminOrgUnitInfo.class, this.prmtAdminOrg, "data");
		dataBinder.registerBinding("applyDate", java.util.Date.class, this.dpApplyDate, "value");
		dataBinder.registerBinding("billState", com.kingdee.eas.hr.base.HRBillStateEnum.class, this.cbBillState, "selectedItem");
		dataBinder.registerBinding("yearMonth", String.class, this.txtyearMonth, "text");
		dataBinder.registerBinding("person", com.kingdee.eas.basedata.person.PersonInfo.class, this.prmtperson, "data");
		dataBinder.registerBinding("empName", String.class, this.txtempName, "text");
		dataBinder.registerBinding("empNumber", String.class, this.txtempNumber, "text");
		dataBinder.registerBinding("positionStatus", String.class, this.txtpositionStatus, "text");
		dataBinder.registerBinding("leaveDate", java.util.Date.class, this.pkleaveDate, "value");
		dataBinder.registerBinding("dormitory", com.kingdee.eas.custom.dormitorysystem.dormitory.DormitoryInfo.class, this.prmtdormitory, "data");
		dataBinder.registerBinding("waterTotalCost", java.math.BigDecimal.class, this.txtwaterTotalCost, "value");
		dataBinder.registerBinding("electricityTotalCost", java.math.BigDecimal.class, this.txtelectricityTotalCost, "value");
		dataBinder.registerBinding("monthWaterAmount", java.math.BigDecimal.class, this.txtmonthWaterAmount, "value");
		dataBinder.registerBinding("monthElectricityAmount", java.math.BigDecimal.class, this.txtmonthElectricityAmount, "value");
		dataBinder.registerBinding("monthDays", java.math.BigDecimal.class, this.txtmonthDays, "value");
		dataBinder.registerBinding("stutas", com.kingdee.eas.custom.dormitorysystem.waterelectricity.WaterElectricityStutas.class, this.stutas, "selectedItem");
		dataBinder.registerBinding("meterReading", String.class, this.txtmeterReading, "text");
		dataBinder.registerBinding("hydropowerStandards", String.class, this.txthydropowerStandards, "text");
		dataBinder.registerBinding("position", com.kingdee.eas.basedata.org.PositionInfo.class, this.prmtposition, "data");
		dataBinder.registerBinding("startDate", java.util.Date.class, this.pkstartDate, "value");
		dataBinder.registerBinding("endDate", java.util.Date.class, this.pkendDate, "value");
		dataBinder.registerBinding("allMonthDays", java.math.BigDecimal.class, this.txtallMonthDays, "value");		
	}
	//Regiester UI State
	private void registerUIState(){		
	}
	public String getUIHandlerClassName() {
	    return "com.kingdee.eas.custom.dormitorysystem.waterelectricity.app.WaterElectricityEditUIHandler";
	}
	public IUIActionPostman prepareInit() {
		IUIActionPostman clientHanlder = super.prepareInit();
		if (clientHanlder != null) {
			RequestContext request = new RequestContext();
    		request.setClassName(getUIHandlerClassName());
			clientHanlder.setRequestContext(request);
		}
		return clientHanlder;
    }
	
	public boolean isPrepareInit() {
    	return false;
    }
    protected void initUIP() {
        super.initUIP();
    }


    /**
     * output onShow method
     */
    public void onShow() throws Exception
    {
        super.onShow();
        this.txtApplier.requestFocusInWindow();
    }

	
	

    /**
     * output setDataObject method
     */
    public void setDataObject(IObjectValue dataObject)
    {
        IObjectValue ov = dataObject;        	    	
        super.setDataObject(ov);
        this.editData = (com.kingdee.eas.custom.dormitorysystem.waterelectricity.WaterElectricityInfo)ov;
    }
    protected void removeByPK(IObjectPK pk) throws Exception {
    	IObjectValue editData = this.editData;
    	super.removeByPK(pk);
    	recycleNumberByOrg(editData,"Admin",editData.getString("number"));
    }
    
    protected void recycleNumberByOrg(IObjectValue editData,String orgType,String number) {
        if (!StringUtils.isEmpty(number))
        {
            try {
            	String companyID = null;            
            	com.kingdee.eas.base.codingrule.ICodingRuleManager iCodingRuleManager = com.kingdee.eas.base.codingrule.CodingRuleManagerFactory.getRemoteInstance();
				if(!com.kingdee.util.StringUtils.isEmpty(orgType) && !"NONE".equalsIgnoreCase(orgType) && com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType))!=null) {
					companyID =com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType)).getString("id");
				}
				else if (com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit() != null) {
					companyID = ((com.kingdee.eas.basedata.org.OrgUnitInfo)com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit()).getString("id");
            	}				
				if (!StringUtils.isEmpty(companyID) && iCodingRuleManager.isExist(editData, companyID) && iCodingRuleManager.isUseIntermitNumber(editData, companyID)) {
					iCodingRuleManager.recycleNumber(editData,companyID,number);					
				}
            }
            catch (Exception e)
            {
                handUIException(e);
            }
        }
    }
    protected void setAutoNumberByOrg(String orgType) {
    	if (editData == null) return;
		if (editData.getNumber() == null) {
            try {
            	String companyID = null;
				if(!com.kingdee.util.StringUtils.isEmpty(orgType) && !"NONE".equalsIgnoreCase(orgType) && com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType))!=null) {
					companyID = com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType)).getString("id");
				}
				else if (com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit() != null) {
					companyID = ((com.kingdee.eas.basedata.org.OrgUnitInfo)com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit()).getString("id");
            	}
				com.kingdee.eas.base.codingrule.ICodingRuleManager iCodingRuleManager = com.kingdee.eas.base.codingrule.CodingRuleManagerFactory.getRemoteInstance();
		        if (iCodingRuleManager.isExist(editData, companyID)) {
		            if (iCodingRuleManager.isAddView(editData, companyID)) {
		            	editData.setNumber(iCodingRuleManager.getNumber(editData,companyID));
		            }
	                txtNumber.setEnabled(false);
		        }
            }
            catch (Exception e) {
                handUIException(e);
                this.oldData = editData;
                com.kingdee.eas.util.SysUtil.abort();
            } 
        } 
        else {
            if (editData.getNumber().trim().length() > 0) {
                txtNumber.setText(editData.getNumber());
            }
        }
    }
			protected com.kingdee.eas.basedata.org.OrgType getMainBizOrgType() {
			return com.kingdee.eas.basedata.org.OrgType.getEnum("Admin");
		}


    /**
     * output loadFields method
     */
    public void loadFields()
    {
        		setAutoNumberByOrg("Admin");
        dataBinder.loadFields();
    }
		protected void setOrgF7(KDBizPromptBox f7,com.kingdee.eas.basedata.org.OrgType orgType) throws Exception
		{
			com.kingdee.eas.basedata.org.client.f7.NewOrgUnitFilterInfoProducer oufip = new com.kingdee.eas.basedata.org.client.f7.NewOrgUnitFilterInfoProducer(orgType);
			oufip.getModel().setIsCUFilter(true);
			f7.setFilterInfoProducer(oufip);
		}

    /**
     * output storeFields method
     */
    public void storeFields()
    {
		dataBinder.storeFields();
    }

	/**
	 * ??????????
	 */
	protected void registerValidator() {
    	getValidateHelper().setCustomValidator( getValidator() );
		getValidateHelper().registerBindProperty("hrOrgUnit", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("approveType", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.id", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.bizDate", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.description", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.person", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.person.number", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.person.name", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.position", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.adminOrg", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.yearMonth", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.leaveDate", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.dormitory", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.waterTotalCost", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.electricityTotalCost", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.monthWaterAmount", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.monthElectricityAmount", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.monthDays", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.stutas", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.positionStatus", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.startDate", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("entrys.endDate", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("number", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("description", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("applier.name", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("adminOrg", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("applyDate", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("billState", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("yearMonth", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("person", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("empName", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("empNumber", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("positionStatus", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("leaveDate", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("dormitory", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("waterTotalCost", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("electricityTotalCost", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("monthWaterAmount", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("monthElectricityAmount", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("monthDays", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("stutas", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("meterReading", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("hydropowerStandards", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("position", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("startDate", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("endDate", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("allMonthDays", ValidateHelper.ON_SAVE);    		
	}



    /**
     * output setOprtState method
     */
    public void setOprtState(String oprtType)
    {
        super.setOprtState(oprtType);
        if (STATUS_ADDNEW.equals(this.oprtState)) {
        } else if (STATUS_EDIT.equals(this.oprtState)) {
        } else if (STATUS_VIEW.equals(this.oprtState)) {
        } else if (STATUS_FINDVIEW.equals(this.oprtState)) {
        }
    }

    /**
     * output kdtEntrys_editStopping method
     */
    protected void kdtEntrys_editStopping(com.kingdee.bos.ctrl.kdf.table.event.KDTEditEvent e) throws Exception
    {
    }

    /**
     * output kdtEntrys_editStopped method
     */
    protected void kdtEntrys_editStopped(com.kingdee.bos.ctrl.kdf.table.event.KDTEditEvent e) throws Exception
    {
    }

    /**
     * output getSelectors method
     */
    public SelectorItemCollection getSelectors()
    {
        SelectorItemCollection sic = new SelectorItemCollection();
		String selectorAll = System.getProperty("selector.all");
		if(StringUtils.isEmpty(selectorAll)){
			selectorAll = "true";
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("hrOrgUnit.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("hrOrgUnit.id"));
        	sic.add(new SelectorItemInfo("hrOrgUnit.number"));
        	sic.add(new SelectorItemInfo("hrOrgUnit.name"));
		}
        sic.add(new SelectorItemInfo("approveType"));
    	sic.add(new SelectorItemInfo("entrys.id"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("entrys.*"));
		}
		else{
		}
    	sic.add(new SelectorItemInfo("entrys.bizDate"));
    	sic.add(new SelectorItemInfo("entrys.description"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("entrys.person.*"));
		}
		else{
	    	sic.add(new SelectorItemInfo("entrys.person.id"));
			sic.add(new SelectorItemInfo("entrys.person.name"));
        	sic.add(new SelectorItemInfo("entrys.person.number"));
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("entrys.position.*"));
		}
		else{
	    	sic.add(new SelectorItemInfo("entrys.position.id"));
			sic.add(new SelectorItemInfo("entrys.position.name"));
        	sic.add(new SelectorItemInfo("entrys.position.number"));
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("entrys.adminOrg.*"));
		}
		else{
	    	sic.add(new SelectorItemInfo("entrys.adminOrg.id"));
			sic.add(new SelectorItemInfo("entrys.adminOrg.name"));
        	sic.add(new SelectorItemInfo("entrys.adminOrg.number"));
		}
    	sic.add(new SelectorItemInfo("entrys.yearMonth"));
    	sic.add(new SelectorItemInfo("entrys.leaveDate"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("entrys.dormitory.*"));
		}
		else{
	    	sic.add(new SelectorItemInfo("entrys.dormitory.id"));
			sic.add(new SelectorItemInfo("entrys.dormitory.RoomNumber"));
			sic.add(new SelectorItemInfo("entrys.dormitory.name"));
        	sic.add(new SelectorItemInfo("entrys.dormitory.number"));
		}
    	sic.add(new SelectorItemInfo("entrys.waterTotalCost"));
    	sic.add(new SelectorItemInfo("entrys.electricityTotalCost"));
    	sic.add(new SelectorItemInfo("entrys.monthWaterAmount"));
    	sic.add(new SelectorItemInfo("entrys.monthElectricityAmount"));
    	sic.add(new SelectorItemInfo("entrys.monthDays"));
    	sic.add(new SelectorItemInfo("entrys.stutas"));
    	sic.add(new SelectorItemInfo("entrys.positionStatus"));
    	sic.add(new SelectorItemInfo("entrys.startDate"));
    	sic.add(new SelectorItemInfo("entrys.endDate"));
        sic.add(new SelectorItemInfo("number"));
        sic.add(new SelectorItemInfo("description"));
        sic.add(new SelectorItemInfo("applier.name"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("adminOrg.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("adminOrg.id"));
        	sic.add(new SelectorItemInfo("adminOrg.number"));
        	sic.add(new SelectorItemInfo("adminOrg.name"));
		}
        sic.add(new SelectorItemInfo("applyDate"));
        sic.add(new SelectorItemInfo("billState"));
        sic.add(new SelectorItemInfo("yearMonth"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("person.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("person.id"));
        	sic.add(new SelectorItemInfo("person.number"));
        	sic.add(new SelectorItemInfo("person.name"));
		}
        sic.add(new SelectorItemInfo("empName"));
        sic.add(new SelectorItemInfo("empNumber"));
        sic.add(new SelectorItemInfo("positionStatus"));
        sic.add(new SelectorItemInfo("leaveDate"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("dormitory.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("dormitory.id"));
        	sic.add(new SelectorItemInfo("dormitory.number"));
        	sic.add(new SelectorItemInfo("dormitory.name"));
        	sic.add(new SelectorItemInfo("dormitory.RoomNumber"));
		}
        sic.add(new SelectorItemInfo("waterTotalCost"));
        sic.add(new SelectorItemInfo("electricityTotalCost"));
        sic.add(new SelectorItemInfo("monthWaterAmount"));
        sic.add(new SelectorItemInfo("monthElectricityAmount"));
        sic.add(new SelectorItemInfo("monthDays"));
        sic.add(new SelectorItemInfo("stutas"));
        sic.add(new SelectorItemInfo("meterReading"));
        sic.add(new SelectorItemInfo("hydropowerStandards"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("position.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("position.id"));
        	sic.add(new SelectorItemInfo("position.number"));
        	sic.add(new SelectorItemInfo("position.name"));
		}
        sic.add(new SelectorItemInfo("startDate"));
        sic.add(new SelectorItemInfo("endDate"));
        sic.add(new SelectorItemInfo("allMonthDays"));
        return sic;
    }        
    	

    /**
     * output actionSubmit_actionPerformed method
     */
    public void actionSubmit_actionPerformed(ActionEvent e) throws Exception
    {
        super.actionSubmit_actionPerformed(e);
    }
    	

    /**
     * output actionPrint_actionPerformed method
     */
    public void actionPrint_actionPerformed(ActionEvent e) throws Exception
    {
        ArrayList idList = new ArrayList();
    	if (editData != null && !StringUtils.isEmpty(editData.getString("id"))) {
    		idList.add(editData.getString("id"));
    	}
        if (idList == null || idList.size() == 0 || getTDQueryPK() == null || getTDFileName() == null)
            return;
        com.kingdee.bos.ctrl.kdf.data.impl.BOSQueryDelegate data = new com.kingdee.eas.framework.util.CommonDataProvider(idList,getTDQueryPK());
        com.kingdee.bos.ctrl.report.forapp.kdnote.client.KDNoteHelper appHlp = new com.kingdee.bos.ctrl.report.forapp.kdnote.client.KDNoteHelper();
        appHlp.print(getTDFileName(), data, javax.swing.SwingUtilities.getWindowAncestor(this));
    }
    	

    /**
     * output actionPrintPreview_actionPerformed method
     */
    public void actionPrintPreview_actionPerformed(ActionEvent e) throws Exception
    {
        ArrayList idList = new ArrayList();
        if (editData != null && !StringUtils.isEmpty(editData.getString("id"))) {
    		idList.add(editData.getString("id"));
    	}
        if (idList == null || idList.size() == 0 || getTDQueryPK() == null || getTDFileName() == null)
            return;
        com.kingdee.bos.ctrl.kdf.data.impl.BOSQueryDelegate data = new com.kingdee.eas.framework.util.CommonDataProvider(idList,getTDQueryPK());
        com.kingdee.bos.ctrl.report.forapp.kdnote.client.KDNoteHelper appHlp = new com.kingdee.bos.ctrl.report.forapp.kdnote.client.KDNoteHelper();
        appHlp.printPreview(getTDFileName(), data, javax.swing.SwingUtilities.getWindowAncestor(this));
    }
    	

    /**
     * output actionAudit_actionPerformed method
     */
    public void actionAudit_actionPerformed(ActionEvent e) throws Exception
    {
        super.actionAudit_actionPerformed(e);
    }
    	

    /**
     * output actionUnaudit_actionPerformed method
     */
    public void actionUnaudit_actionPerformed(ActionEvent e) throws Exception
    {
        super.actionUnaudit_actionPerformed(e);
    }
	public RequestContext prepareActionSubmit(IItemAction itemAction) throws Exception {
			RequestContext request = super.prepareActionSubmit(itemAction);		
		if (request != null) {
    		request.setClassName(getUIHandlerClassName());
		}
		return request;
    }
	
	public boolean isPrepareActionSubmit() {
    	return false;
    }
	public RequestContext prepareActionPrint(IItemAction itemAction) throws Exception {
			RequestContext request = super.prepareActionPrint(itemAction);		
		if (request != null) {
    		request.setClassName(getUIHandlerClassName());
		}
		return request;
    }
	
	public boolean isPrepareActionPrint() {
    	return false;
    }
	public RequestContext prepareActionPrintPreview(IItemAction itemAction) throws Exception {
			RequestContext request = super.prepareActionPrintPreview(itemAction);		
		if (request != null) {
    		request.setClassName(getUIHandlerClassName());
		}
		return request;
    }
	
	public boolean isPrepareActionPrintPreview() {
    	return false;
    }
	public RequestContext prepareActionAudit(IItemAction itemAction) throws Exception {
			RequestContext request = super.prepareActionAudit(itemAction);		
		if (request != null) {
    		request.setClassName(getUIHandlerClassName());
		}
		return request;
    }
	
	public boolean isPrepareActionAudit() {
    	return false;
    }
	public RequestContext prepareActionUnaudit(IItemAction itemAction) throws Exception {
			RequestContext request = super.prepareActionUnaudit(itemAction);		
		if (request != null) {
    		request.setClassName(getUIHandlerClassName());
		}
		return request;
    }
	
	public boolean isPrepareActionUnaudit() {
    	return false;
    }

    /**
     * output getMetaDataPK method
     */
    public IMetaDataPK getMetaDataPK()
    {
        return new MetaDataPK("com.kingdee.eas.custom.dormitorysystem.waterelectricity.client", "WaterElectricityEditUI");
    }
    /**
     * output isBindWorkFlow method
     */
    public boolean isBindWorkFlow()
    {
        return true;
    }

    /**
     * output getEditUIName method
     */
    protected String getEditUIName()
    {
        return com.kingdee.eas.custom.dormitorysystem.waterelectricity.client.WaterElectricityEditUI.class.getName();
    }

    /**
     * output getBizInterface method
     */
    protected com.kingdee.eas.framework.ICoreBase getBizInterface() throws Exception
    {
        return com.kingdee.eas.custom.dormitorysystem.waterelectricity.WaterElectricityFactory.getRemoteInstance();
    }

    /**
     * output createNewData method
     */
    protected IObjectValue createNewData()
    {
        com.kingdee.eas.custom.dormitorysystem.waterelectricity.WaterElectricityInfo objectValue = new com.kingdee.eas.custom.dormitorysystem.waterelectricity.WaterElectricityInfo();
        objectValue.setCreator((com.kingdee.eas.base.permission.UserInfo)(com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentUser()));		
        return objectValue;
    }


    	protected String getTDFileName() {
    	return "/bim/custom/dormitorysystem/waterelectricity/WaterElectricity";
	}
    protected IMetaDataPK getTDQueryPK() {
    	return new MetaDataPK("com.kingdee.eas.custom.dormitorysystem.waterelectricity.app.WaterElectricityQuery");
	}
    

    /**
     * output getDetailTable method
     */
    protected KDTable getDetailTable() {
        return kdtEntrys;
	}
    /**
     * output applyDefaultValue method
     */
    protected void applyDefaultValue(IObjectValue vo) {        
		vo.put("stutas","Lock");
        
    }        
	protected void setFieldsNull(com.kingdee.bos.dao.AbstractObjectValue arg0) {
		super.setFieldsNull(arg0);
		arg0.put("number",null);
	}

}